Loading...
Searching...
No Matches
Dune Namespace Reference

## Namespaces

namespace | Geo
namespace | QuadratureType
| Defines an `enum` for currently available quadrature rules.
namespace | RefinementImp
| This namespace contains the implementation of Refinement.
namespace | GeometryTypes
| Predefined GeometryTypes for common geometries.

## Classes

class | AffineGeometry
| Implementation of the Geometry interface for affine geometries. More...
class | AxisAlignedCubeGeometry
| A geometry implementation for axis-aligned hypercubes. More...
struct | Dim
| Static tag representing a dimension. More...
struct | Codim
| Static tag representing a codimension. More...
class | GeneralVertexOrder
| Class providing information on the ordering of vertices. More...
class | LocalFiniteElementGeometry
| Geometry implementation based on local-basis function parametrization. More...
class | MappedGeometry
| Geometry parametrized by a LocalFunction and a LocalGeometry. More...
struct | MultiLinearGeometryTraits
| default traits class for MultiLinearGeometry More...
class | MultiLinearGeometry
| generic geometry implementation based on corner coordinates More...
class | CachedMultiLinearGeometry
| Implement a MultiLinearGeometry with additional caching. More...
class | QuadraturePoint
| Single evaluation point in a quadrature rule. More...
class | QuadratureOrderOutOfRange
| Exception thrown if a desired QuadratureRule is not available, because the requested order is to high. More...
class | QuadratureRule
| Abstract base class for quadrature rules. More...
class | QuadratureRuleFactory
| Factory class for creation of quadrature rules, depending on GeometryType, order and QuadratureType. More...
class | QuadratureRules
| A container for all quadrature rules of dimension dim. More...
class | QuadratureRuleFactory< ctype, 0 >
class | QuadratureRuleFactory< ctype, 1 >
class | QuadratureRuleFactory< ctype, 2 >
class | QuadratureRuleFactory< ctype, 3 >
class | RefinementIntervals
| Holds the number of refined intervals per axis needed for virtual and static refinement. More...
class | StaticRefinement
| Wrap each Refinement implementation to get a consistent interface. More...
struct | TopologyFactory
| Provide a factory over the generic topologies. More...
struct | TopologySingletonFactory
| A wrapper for a TopologyFactory providing singleton storage. Same usage as TopologyFactory but with empty release method an internal storage. More...
class | GeometryType
| Unique label for each type of entities that can occur in DUNE grids. More...
class | LocalGeometryTypeIndex
| Compute per-dimension indices for geometry types. More...
class | GlobalGeometryTypeIndex
| Compute indices for geometry types, taking the dimension into account. More...
class | VirtualRefinementSubEntityIteratorSpecial
class | VirtualRefinementSubEntityIteratorSpecial< dimension, CoordType, dimension >
class | VirtualRefinementSubEntityIteratorSpecial< dimension, CoordType, 0 >
class | VirtualRefinementSubEntityIteratorBackSpecial
class | VirtualRefinementSubEntityIteratorBackSpecial< dimension, CoordType, dimension >
class | VirtualRefinementSubEntityIteratorBackSpecial< dimension, CoordType, 0 >
class | VirtualRefinementImp
class | VirtualRefinementImpSubEntityIteratorBackSpecial
class | VirtualRefinementImpSubEntityIteratorBackSpecial< topologyId, CoordType, coerceToId, dimension, dimension >
class | VirtualRefinementImpSubEntityIteratorBackSpecial< topologyId, CoordType, coerceToId, dimension, 0 >
class | RefinementBuilder
class | RefinementBuilder< 1, CoordType >
class | RefinementBuilder< 3, CoordType >
class | VirtualRefinement
| VirtualRefinement base class. More...
struct | ReferenceElements
| Class providing access to the singletons of the reference elements. More...

## Typedefs

template<typename... T>
using | ReferenceElement = decltype(referenceElement(std::declval<T>()...))

## Functions

template<class InIterator, class OutIterator>
void | reduceOrder (const InIterator &inBegin, const InIterator &inEnd, OutIterator outIt)
| Algorithm to reduce vertex order information.
template<class I, class LFE, class GlobalCoordinate>
| LocalFiniteElementGeometry (Geo::ReferenceElement< I >, const LFE &, std::vector< GlobalCoordinate >) -> LocalFiniteElementGeometry< LFE, GlobalCoordinate::dimension >
template<class I, class LFE, class F, class Range = std::invoke_result_t<F,Impl::LocalCoordinate_t<LFE>>>
| LocalFiniteElementGeometry (Geo::ReferenceElement< I >, const LFE &, const F &) -> LocalFiniteElementGeometry< LFE, Range::dimension >
template<class LFE, class GlobalCoordinate>
| LocalFiniteElementGeometry (GeometryType, const LFE &localFE, std::vector< GlobalCoordinate >) -> LocalFiniteElementGeometry< LFE, GlobalCoordinate::dimension >
template<class LFE, class F, class Range = std::invoke_result_t<F,Impl::LocalCoordinate_t<LFE>>>
| LocalFiniteElementGeometry (GeometryType, const LFE &, const F &) -> LocalFiniteElementGeometry< LFE, Range::dimension >
template<class Map, class Geo>
| MappedGeometry (const Map &, const Geo &) -> MappedGeometry< Map, Geo >
template<class Map, class Geo>
| MappedGeometry (const Map &, const Geo &, bool) -> MappedGeometry< Map, Geo >
template<typename... T>
unspecified value type | referenceElement (T &&... t)
| Returns a reference element for the objects t....
template<typename T, int dim>
auto | referenceElement (const Dune::GeometryType &gt, Dune::Dim< dim >={})
| Returns a reference element of dimension dim for the given geometry type and coordinate field type.
template<typename T, int dim, std::enable_if_t< IsNumber< std::decay_t< T > >::value, int > = 0>
auto | referenceElement (const T &, const Dune::GeometryType &gt, Dune::Dim< dim >)
| Returns a reference element of dimension dim for the given geometry type and coordinate field type.
RefinementIntervals | refinementIntervals (int intervals)
| Creates a RefinementIntervals object.
RefinementIntervals | refinementLevels (int levels)
| Creates a RefinementIntervals object.
std::ostream & | operator<< (std::ostream &s, const GeometryType &a)
| Prints the type to an output stream.
GeometryType | geometryTypeFromVertexCount (unsigned int dim, unsigned int vertices)
| Utility function to construct the correct geometry type given the dimension and the number of vertices.
template<int dimension, class CoordType>
VirtualRefinement< dimension, CoordType > & | buildRefinement (GeometryType geometryType, GeometryType coerceTo)
| return a reference to the VirtualRefinement according to the parameters

## Typedef Documentation

## ReferenceElement

template<typename... T>

using Dune::ReferenceElement = decltype(referenceElement(std::declval<T>()...))

## Function Documentation

## buildRefinement()

template<int dimension, class CoordType>

VirtualRefinement< dimension, CoordType > & Dune::buildRefinement | ( | GeometryType | geometryType,
|  | GeometryType | coerceTo )

return a reference to the VirtualRefinement according to the parameters

Template Parameters

  dimension | Dimension of the element to refine
  CoordType | C++ type of the coordinates

Exceptions

  NotImplemented | There is no Refinement implementation for the specified parameters.

Parameters

  geometryType | geometry type of the refined element
  coerceTo | geometry type of the subelements

## geometryTypeFromVertexCount()

GeometryType Dune::geometryTypeFromVertexCount | ( | unsigned int | dim,
|  | unsigned int | vertices )

inline

Utility function to construct the correct geometry type given the dimension and the number of vertices.

Note
  This code only works up to dimension 3. In higher dimensions the number of vertices does not uniquely identify the type of polyhedron.

## LocalFiniteElementGeometry() [1/4]

template<class I, class LFE, class F, class Range = std::invoke_result_t<F,Impl::LocalCoordinate_t<LFE>>>

Dune::LocalFiniteElementGeometry | ( | Geo::ReferenceElement< I > | ,
|  | const LFE & | ,
|  | const F & | )->LocalFiniteElementGeometry< LFE, Range::dimension >

## LocalFiniteElementGeometry() [2/4]

template<class I, class LFE, class GlobalCoordinate>

Dune::LocalFiniteElementGeometry | ( | Geo::ReferenceElement< I > | ,
|  | const LFE & | ,
|  | std::vector< GlobalCoordinate > | )->LocalFiniteElementGeometry< LFE, GlobalCoordinate::dimension >

## LocalFiniteElementGeometry() [3/4]

template<class LFE, class F, class Range = std::invoke_result_t<F,Impl::LocalCoordinate_t<LFE>>>

Dune::LocalFiniteElementGeometry | ( | GeometryType | ,
|  | const LFE & | ,
|  | const F & | )->LocalFiniteElementGeometry< LFE, Range::dimension >

## LocalFiniteElementGeometry() [4/4]

template<class LFE, class GlobalCoordinate>

Dune::LocalFiniteElementGeometry | ( | GeometryType | ,
|  | const LFE & | localFE,
|  | std::vector< GlobalCoordinate > | )->LocalFiniteElementGeometry< LFE, GlobalCoordinate::dimension >

## MappedGeometry() [1/2]

template<class Map, class Geo>

Dune::MappedGeometry | ( | const Map & | ,
|  | const Geo & | )->MappedGeometry< Map, Geo >

## MappedGeometry() [2/2]

template<class Map, class Geo>

Dune::MappedGeometry | ( | const Map & | ,
|  | const Geo & | ,
|  | bool | )->MappedGeometry< Map, Geo >

## operator<<()

std::ostream & Dune::operator<< | ( | std::ostream & | s,
|  | const GeometryType & | a )

inline

Prints the type to an output stream.

## reduceOrder()

template<class InIterator, class OutIterator>

void Dune::reduceOrder | ( | const InIterator & | inBegin,
|  | const InIterator & | inEnd,
|  | OutIterator | outIt )

Algorithm to reduce vertex order information.

#include <dune/geometry/generalvertexorder.hh>
generalvertexorder.hh

Parameters

  inBegin | Start of the range of ids to reduce.
  inEnd | End of the range of ids to reduce.
  outIt | Start of the sequence where to store the result.

`inBegin` and `inEnd` must be ForwardIterators; their `value_type` may constant. `outIt` must be an OutputIterator and must allow `std::distance(inBegin,inEnd)` increments. Complexity is quadratic.

See also
  GeneralVertexOrder, VertexOrderByIdFactory